
#include <stdio.h>
#define MAX_ENTRIES 100


struct st_type {
    int     entries[MAX_ENTRIES];
    int     num_elements;
};
typedef struct st_type stack;


void st_init(stack *s)
{
    s->num_elements = 0;
}

int st_top(stack *s)
{
    if (s->num_elements == 0) {
        fprintf(stderr, "Error: stack empty\n");
        return -1;
    } 

    return s->entries[s->num_elements-1];
}

void st_push(stack *s, int d)
{
    if (s->num_elements < MAX_ENTRIES)
        s->entries[s->num_elements++] = d;
    else
        fprintf(stderr, "Error: stack full\n");
}

int st_pop(stack *s)
{
    if (s->num_elements == 0)
        fprintf(stderr, "Error: stack empty\n");
    else
        s->num_elements--;
    return s->entries[s->num_elements];
}

int main(){
    stack s;

    st_init(&s);

    st_push(&s, 30);
    st_push(&s, 40);

    printf("top: %d\n", st_top(&s));

    st_pop(&s);
    printf("top: %d\n", st_top(&s));

    st_pop(&s);
    printf("top: %d\n", st_top(&s));

    return 0; 
}
